/*
* 文件版本：0.0.1
* 文件作者：万鑫
* 开源协议：MIT License
*
*/

//基础方法
var Xui = (function() {"use strict";
	var x = {}, undefined, cache = {};
	x.url = 'http://www.abangmang.cn';
	x.mUrl = 'http://m.abangmang.cn';
	//根文件地址
	x.fileUrl = x.url + '/d/file/';
	x.defaultUserPic = '../../image/nouserpic.gif';
	x.isType = function(obj, type) {
		return typeof obj === type;
	};
	x.isNumber = function(obj) {
		var that = this;
		return !isNaN(obj);
	};
	x.isFunction = function(obj) {
		return this.isType(obj, 'function');
	};
	x.boolean = function(obj) {
		return this.isType(obj, 'boolean');
	};
	x.isString = function(obj) {
		return this.isType(obj, 'string');
	};
	x.isJson = function(obj) {
		return this.isType(obj, 'object') && Object.prototype.toString.call(obj).toLowerCase() == '[object object]' && !obj.length;
	};
	x.isArray = function(obj) {
		return Array.isArray(obj);
	};
	x.uzStore = function() {
		var ls = window.localStorage;
		if ((/android/gi).test(navigator.appVersion)) {
			ls = os.localStorage();
		}
		return ls;
	};
	x.setStore = function(key, value) {
		var that = this;
		if (arguments.length === 2) {
			var v = value;
			if (that.isType(v, 'object')) {
				v = JSON.stringify(v);
				v = 'obj-' + v;
			} else {
				v = 'str-' + v;
			}
			var ls = that.uzStore();
			if (ls) {
				ls.setItem(key, v);
			}
		}
	};
	x.getStore = function(key) {
		var that = this;

		var ls = that.uzStore();
		if (ls) {
			var v = ls.getItem(key);
			if (!v) {
				return;
			}
			if (v.indexOf('obj-') === 0) {
				v = v.slice(4);
				return JSON.parse(v);
			} else if (v.indexOf('str-') === 0) {
				return v.slice(4);
			}
		}
	};
	x.removeStore = function(key) {
		var that = this;

		var ls = that.uzStore();
		if (ls && key) {
			ls.removeItem(key);
		}
	};
	x.clearStore = function() {
		var that = this;

		var ls = that.uzStore();
		if (ls) {
			ls.clear();
		}
	};
	x.jsonToGet = function(param) {
		if (!this.isJson(param)) {
			return param;
		}
		var arr = [];
		for (var i in param) {
			var str = i + "=" + param[i];
			arr.push(str);
		}
		return arr.join("&");
	}
	//H5页面缓存
	cache.set = function(param) {
		var that = x;
		var json = that.getStore(param.name);
		json = json || {};
		if (that.isJson(param.arg)) {
			that.setStore(param.name, that.setData({}, [json, param.arg], true));
		} else {
			that.toast(param.name + ':arg不为对象');
		}
	};
	cache.get = function(param) {
		var that = x;
		var json = that.getStore(param.name);
		json = json || {};
		if (that.isArray(param.arg)) {
			return that.getData(json, param.arg);
		} else if (that.isString(param.arg) || that.isNumber(param.arg)) {
			return json[param.arg];
		} else {
			return json;
		}
	};
	cache.remove = function(param) {
		var that = x;
		var json = that.getStore(param.name);
		json = json || {};
		if (!that.isType(param.arg, 'object')) {
			that.setStore(param.name, that.removeData(json, param.arg));
		} else {
			that.toast(param.name + ':arg不为数组或字符串');
		}
	};
	cache.clear = function(param) {
		var that = x;
		var json = that.getStore(param.name);
		json = json || {};
		if (that.isArray(param.arg) || that.isString(param.arg)) {
			that.setStore(param.name, that.clearData(json, param.arg));
		} else {
			that.removeStore(param.name);
		}
	};
	cache.userid = function() {
		var user = x.getStore('user');
		user = user || {};
		user.userid = user.userid || 0;
		return user.userid;
	}
	//会员操作
	x.setUser = function(param) {
		this.cache.set({
			name : 'user',
			arg : param
		})
	};
	x.getUser = function(param) {
		return this.cache.get({
			name : 'user',
			arg : param
		})
	};
	x.removeUser = function(param) {
		this.cache.remove({
			name : 'user',
			arg : param
		})
	};
	x.clearUser = function(param) {
		this.cache.clear({
			name : 'user',
			arg : param
		})
	};
	//信息操作
	x.setInfo = function(param) {
		this.cache.set({
			name : 'info' + this.getUser('userid'),
			arg : param
		})
	};
	x.getInfo = function(param) {
		return this.cache.get({
			name : 'info' + this.getUser('userid'),
			arg : param
		})
	};
	x.removeInfo = function(param) {
		this.cache.remove({
			name : 'info' + this.getUser('userid'),
			arg : param
		})
	};
	x.clearInfo = function(param) {
		this.cache.clear({
			name : 'info' + this.getUser('userid'),
			arg : param
		})
	};
	//参数设置
	x.setConfig = function(param) {
		this.cache.set({
			name : 'config',
			arg : param
		})
	};
	x.getConfig = function(param) {
		return this.cache.get({
			name : 'config',
			arg : param
		})
	};
	x.removeConfig = function(param) {
		this.cache.remove({
			name : 'config',
			arg : param
		})
	};
	x.clearConfig = function(param) {
		this.cache.clear({
			name : 'config',
			arg : param
		})
	};
	//关注操作
	x.setFocus = function(userid) {
		var myFocus = x.getUser('focus') || [];
		if (x.isFocus(userid) == -1) {
			myFocus.push(userid);
			var myFocusCount = x.getUser('focusCount') || 0;
			myFocusCount++;
			x.setUser({
				focus : myFocus,
				focusCount : myFocusCount
			});
		}
	}
	x.removeFocus = function(userid) {
		var myFocus = x.getUser('focus') || [];
		var index = x.isFocus(userid);
		if (index > -1) {
			myFocus.splice(index, 1);
			var myFocusCount = x.getUser('focusCount') || 0;
			myFocusCount++;
			x.setUser({
				focus : myFocus,
				focusCount : myFocusCount
			});
		}
	}
	x.isFocus = function(userid) {
		var myFocus = x.getUser('focus') || [];
		return myFocus.indexOf(userid);
	}
	//JSON操作--------
	/*
	 des={}
	 src数组类型
	 override是否深度合并
	 * */
	x.setData = function(des, src, override) {
		if (this.isArray(src)) {
			for (var i = 0, len = src.length; i < len; i++)
				this.setData(des, src[i], override);
		} else if (this.isJson(src)) {
			for (var i in src) {
				if (override || !( i in des)) {
					des[i] = src[i];
				}
			}
		}
		return des;
	};
	x.getData = function(json, obj) {
		if (!this.isJson(json)) {
			return false;
		}
		if (this.isArray(obj)) {
			return this.clearData(json, obj);
		} else if (this.isString(obj) || this.isNumber(obj)) {
			return json[obj];
		}
	};
	x.removeData = function(json, obj) {
		if (!this.isJson(json)) {
			return false;
		}
		if (this.isArray(obj)) {
			for (var i = 0, max = obj.length; i < max; i++) {
				delete json[obj[i]];
			}
			return json;
		} else if (this.isString(obj) || this.isNumber(obj)) {
			delete json[obj];
			return json;
		}
	};
	//清空JSON
	//json=要删除的json，obj=json中要保留的值
	x.clearData = function(json, obj) {
		if (!this.isJson(json)) {
			return false;
		}
		if (this.isArray(obj)) {
			var newJson = {};
			for (var i = 0, max = obj.length; i < max; i++) {
				newJson[obj[i]] = json[obj[i]] ? json[obj[i]] : '';
			}
			return newJson;
		} else if (this.isString(obj) || this.isNumber(obj)) {
			return json[obj];
		} else {
			return {};
		}
	};
	//左侧补零 num字符串 n总长度
	x.padleft = function(num, n) {
		num = num || 0;
		var len = num.toString().length;
		while (len < n) {
			num = "0" + num;
			len++;
		}
		return num;
	};
	//右侧补零
	x.padright = function(num, n) {
		num = num || 0;
		var len = num.toString().length;
		while (len < n) {
			num = num + "0";
			len++;
		}
		return num;
	};
	//初始化当前时间
	x.initTime = function() {
		var time = 0;
		time = Date.parse(new Date());
		time = time / 1000;
		return time;
	};
	x.rand = function(m) {
		var num = '';
		for (var i = 0; i < m; i++) {
			var val = parseInt(Math.random() * 10, 10);
			if (i === 0 && val === 0) {
				i--;
				continue;
			}
			num += val;
		}
		return num;
	};
	x.isPositiveNum = function(number) {
		var re = /^[0-9]*[1-9][0-9]*$/;
		return re.test(number)
	}
	//时间戳转换成日期
	x.unixToTime = function(num, format) {
		num = num * 1000;
		format = format || 'Y-m-d H:i:s';
		var now = new Date(num);
		var year = now.getFullYear();
		var month = now.getMonth() + 1;
		var date = now.getDate();
		var hour = now.getHours();
		var minute = now.getMinutes();
		var second = now.getSeconds();
		if (month.toString().length == 1) {
			month = '0' + month;
		}
		if (date.toString().length == 1) {
			date = '0' + date;
		}
		if (format == 'Y-m-d') {
			return year + "-" + month + "-" + date;
		} else if (format == 'm-d') {
			return month + "-" + date;
		} else {
			return year + "-" + month + "-" + date + " " + hour + ":" + minute + ":" + second;
		}
	};
	//时间差计算(时间戳形式)
	x.dateDiff = function(hisTime) {
		if (hisTime.toString().indexOf("-") > -1) {
			hisTime = Date.parse(hisTime.replace(/-/gi, "/"));
		}
		if (hisTime.toString().length == 10) {
			hisTime = hisTime * 1000;
		}
		if (!arguments.length)
			return '';
		var arg = arguments, now = arg[1] ? arg[1] : new Date().getTime(), diffValue = now - hisTime, result = '', minute = 1000 * 60, hour = minute * 60, day = hour * 24, halfamonth = day * 15, month = day * 30, year = month * 12, _year = diffValue / year, _month = diffValue / month, _week = diffValue / (7 * day), _day = diffValue / day, _hour = diffValue / hour, _min = diffValue / minute;

		if (_year >= 1)
			result = parseInt(_year) + "年前";
		else if (_month >= 1)
			result = parseInt(_month) + "个月前";
		else if (_week >= 1)
			result = parseInt(_week) + "周前";
		else if (_day >= 1)
			result = parseInt(_day) + "天前";
		else if (_hour >= 1)
			result = parseInt(_hour) + "小时前";
		else if (_min >= 1)
			result = parseInt(_min) + "分钟前";
		else
			result = "刚刚";
		return result;
	};
	x.isSign = function(hisTime) {
		if (!hisTime || hisTime == '0000-00-00')
			return false;
		hisTime = Date.parse(hisTime.replace(/-/gi, "/"));
		var now = new Date().getTime(), diffValue = now - hisTime, minute = 1000 * 60, hour = minute * 60, day = hour * 24, _day = diffValue / day;
		if (_day >= 1) {
			return false;
		} else {
			return true;
		}
	}
	x.cache = cache;
	return x;
})()
window.x = Xui;

//APICloud基础方法
;(function(x) {"use strict";
	// APICloud方法默认配置
	var config = {
		openWin : {
			scrollToTop : true,
			hScrollBarEnabled : false,
			slidBackType : "edge",
			animation : {
				type : "push",
				subType : "from_right",
				duration : 300
			}
		},
		closeWin : {
			animation : {
				type : "push",
				subType : "from_right",
				duration : 300
			}
		},
		closeToWin : {
			animation : {
				type : "push",
				subType : "from_right",
				duration : 300
			}
		},
		setFrameGroupIndex : {
			scroll : true
		},
		getPicture : {
			encodingType : "jpg",
			quality : 80
		},
		alert : {
			title : "系统提示"
		},
		confirm : {
			title : "请选择",
			buttons : ["确定", "取消"]
		},
		prompt : {
			title : "请输入"
		},
		actionSheet : {
			title : "请选择"
		},
		openPicker : {
			type : "date",
			title : "选择时间"
		},
		scrolltobottom : {
			extra : {
				threshold : 100
			}
		}
	};

	x.isApp = function() {
		return typeof api !== 'undefined' && typeof api.appVersion !== 'undefined';
	};
	x.ready = function(callback) {
		var that = this;
		window.apiready = function() {
			if (that.isFunction(callback)) {
				callback();
			}
		}
	};
	//APICloud方法
	x.openWin = function(param) {
		param = this.setData({}, [config.openWin, param], true);
		if (this.systemType == 'ios') {
			param.delay = 0;
		} else {
			if (parseFloat(x.systemVersion) >= 5) {
				param.delay = 0;
			} else {
				param.delay = 300;
			}
		}
		if (this.isApp()) {
			api.openWin(param);
		}
	};
	x.closeWin = function(name) {
		if (this.isApp()) {
			if (this.isArray(name)) {
				for (var i = 0, max = name.length; i < max; i++) {
					this.closeWin(name[i]);
				}
			} else if (this.isString(name) || this.isNumber(name)) {
				api.closeWin({
					name : name
				});
			} else {
				api.closeWin();
			}
		}
	};
	x.closeToWin = function(name) {
		if (this.isApp()) {
			api.closeToWin({
				name : name
			});
		}
	};
	x.openFrame = function(param) {
		param.footer = param.footer || 0;
		param.rect = param.rect || {};
		if(x.isNumber(param.rect.y)){
			param.rect.y=param.rect.y;
		}else{
			param.rect.y=45 + x.getConfig('fixStatusBar');
		}
		param.rect.h = param.rect.h || x.winHeight - (45 + x.getConfig('fixStatusBar') + param.footer);
		if (this.isApp()) {
			api.openFrame(param);
		}
	};
	x.closeFrame = function(name) {
		if (this.isApp()) {
			if (this.isArray(name)) {
				for (var i = 0, max = name.length; i < max; i++) {
					this.closeFrame(name[i]);
				}
			} else if (this.isString(name) || this.isNumber(name)) {
				api.closeFrame({
					name : name
				});
			} else {
				api.closeFrame();
			}
		}
	};
	x.setFrameAttr = function(param) {
		if (this.isApp()) {
			api.setFrameAttr(param);
		}
	};
	x.openFrameGroup = function(param) {
		var that = this;
		if (that.isApp()) {
			param.footer = param.footer || 0;
			param.rect = {
				y : 45 + x.getConfig('fixStatusBar'),
				h : x.winHeight - (45 + x.getConfig('fixStatusBar') + param.footer)
			}
			api.openFrameGroup(param, function(ret, err) {
				if (that.isFunction(param.success)) {
					param.success(ret.index);
				}
			});
		}
	};
	x.closeFrameGroup = function(name) {
		if (this.isApp()) {
			api.closeFrameGroup({
				name : name
			});
		}
	};
	x.setFrameGroupIndex = function(param) {
		param = this.setData({}, [config.setFrameGroupIndex, param], true);
		if (this.isApp()) {
			api.setFrameGroupIndex(param);
		}
	};
	x.execScript = function() {
		var that = this;
		if (that.isApp()) {
			if (arguments.length == 1) {
				if (that.isArray(arguments[0])) {
					arguments[0].forEach(function(arg) {
						that.execScript(arg);
					})
				} else if (that.isJson(arguments[0])) {
					api.execScript(arguments[0]);
				}
			} else if (arguments.length == 2) {
				api.execScript({
					name : arguments[0],
					frameName : arguments[0],
					script : arguments[1]
				});
			} else if (arguments.length == 3) {
				api.execScript({
					name : arguments[0],
					frameName : arguments[1],
					script : arguments[2]
				});
			}
		}
	};
	x.openApp = function(param) {
		if (this.isApp()) {
			api.openApp(param);
		}
	};
	x.rebootApp = function() {
		if (this.isApp()) {
			api.rebootApp();
		}
	};
	x.closeWidget = function(param) {
		if (this.isApp()) {
			api.closeWidget(param);
		}
	};
	x.ajax = function(param) {
		if (this.isApp()) {
			var that = this;
			param.dataType = 'json';
			api.ajax(param, function(ret, err) {
				//console.log(ret);
				//ret=JSON.parse(ret);
				if (ret) {
					var arg = ret.body || ret;
					if (arg.state == 'nologin') {
						if (that.isFunction(param.error)) {
							x.toast(ret.msg);
							setTimeout(function() {
								x.openPage('login');
							}, 300)
							param.error(arg);
						}
					} else if (arg.state == 'no') {
						if (that.isFunction(param.error)) {
							param.error(arg);
						}
					} else if (arg.state == 'yes') {
						if (that.isFunction(param.success)) {
							param.success(arg);
						}
					} else {
						if (that.isFunction(param.error)) {
							param.error(arg);
						}
					}
				} else {
					if (that.isFunction(param.error)) {
						param.error(err);
					}
				}
			});
		} else {
			//指定提交方式的默认值
			param.method = param.method || "get";
			//设置是否异步，默认为true(异步)
			param.async = param.async || true;
			//设置数据的默认值
			param.data = param.data || {};
			//设置输出类型
			param.dataType = param.dataType || 'json';
			if (window.XMLHttpRequest) {
				//非ie
				var ajax = new XMLHttpRequest();
			} else {
				//ie
				var ajax = new ActiveXObject("Microsoft.XMLHTTP");
			}
			//区分get和post
			if (param.method == "post") {
				ajax.open(param.method, param.url, param.async);
				ajax.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
				param.data = x.jsonToGet(param.data);
				ajax.send(param.data);
			} else {
				//get  test.php?xx=xx&aa=xx
				//var url = param.url + "?" + x.jsonToGet(param.data);
				ajax.open(param.method, param.url, param.async);
				ajax.send();
			}

			ajax.onreadystatechange = function() {
				if (ajax.readyState == 4) {
					if (ajax.status >= 200 && ajax.status < 300 || ajax.status == 304) {
						if (param.dataType == 'json') {
							var arg = eval('(' + ajax.responseText + ')');
							if (arg.state == 'yes') {
								if (x.isFunction(param.success)) {
									param.success(arg);
								}
							} else {
								if (x.isFunction(param.error)) {
									param.error(arg);
								}
							}
						} else {
							param.success(ajax.responseText);
						}
					} else {
						if (x.isFunction(param.error)) {
							param.error(ajax.status);
						}
					}
				}
			}
		}
	};
	x.download = function(param) {
		var that = this;
		if (that.isApp()) {
			api.download(param, function(ret, err) {
				if (ret.state == 1) {
					if (that.isFunction(param.success)) {
						param.success();
					}
				} else if (ret.state == 2) {
					if (that.isFunction(param.error)) {
						param.error();
					}
				}
			});
		}
	};
	x.setPrefs = function(key, value) {
		if (this.isApp()) {
			api.setPrefs({
				key : key,
				value : value
			});
		}
	};
	x.getPrefs = function(key) {
		if (this.isApp()) {
			return api.getPrefs({
				sync : true,
				key : key
			});
		}
	};
	x.removePrefs = function(key) {
		if (this.isApp()) {
			api.removePrefs({
				key : key
			});
		};
	};
	x.clearCache = function(callback) {
		var that = this;
		if (that.isApp()) {
			api.clearCache(function() {
				if (that.isFunction(callback)) {
					callback();
				};
			});
		}
	};
	x.getCacheSize = function(callback) {
		var that = this;
		if (that.isApp()) {
			api.getCacheSize(function(ret) {
				if (that.isFunction(callback)) {
					callback(ret.size);
				};
			});
		};
	};
	x.call = function(number) {
		if (this.isApp()) {
			api.call({
				type : 'tel_prompt',
				number : number
			});
		};
	};
	x.setStatusBarStyle = function() {
		if (this.isApp()) {
			api.setStatusBarStyle({
				style : 'light'
			});
		};
	};
	x.alert = function(param) {
		var that = this;
		if (that.isApp()) {
			if (this.isJson(param)) {
				param = that.setData({}, [config.alert, param], true);
				api.alert(param, function(ret, err) {
					if (ret.buttonIndex == 1) {
						if (that.isFunction(param.success)) {
							param.success();
						}
					}
				});
			} else {
				api.alert({
					msg : param
				})
			}
		}
	};
	x.confirm = function(param) {
		var that = this;
		if (that.isApp()) {
			param = that.setData({}, [config.confirm, param], true);
			api.confirm(param, function(ret, err) {
				if (ret.buttonIndex == 1) {
					if (that.isFunction(param.success)) {
						param.success(ret.buttonIndex);
					}
				}
				if(param.buttons.length==3){
					if(ret.buttonIndex==2){
						param.success(ret.buttonIndex);
					}
				}
			});
		};
	};
	x.prompt = function(param) {
		var that = this;
		if (that.isApp()) {
			param = that.setData({}, [config.prompt, param], true);
			api.prompt(param, function(ret, err) {
				if (ret.buttonIndex == 2) {
					if (that.isFunction(param.success)) {
						param.success(ret.text);
					}
				}
			});
		};
	};
	x.actionSheet = function(param) {
		var that = this;
		if (that.isApp()) {
			param = that.setData({}, [config.actionSheet, param], true);
			api.actionSheet(param, function(ret, err) {
				if (ret.buttonIndex > param.buttons.length) {
					return;
				};
				if (that.isFunction(param.success)) {
					param.success(ret.buttonIndex - 1, param.buttons[ret.buttonIndex - 1]);
				}
			});
		};
	};
	x.showProgress = function(param) {
		if (this.isApp()) {
			api.showProgress(param);
		} else {
			x.auiToast = new auiToast();
			x.auiToast.loading({
				title : "加载中",
				duration : 2000
			});
		}
	};
	x.hideProgress = function() {
		if (this.isApp()) {
			api.hideProgress();
		} else {
			x.auiToast.hide();
		}
	};
	x.toast = function(param) {
		if (this.isApp()) {
			if (this.isJson(param)) {
				api.toast(param);
			} else {
				api.toast({
					msg : param
				});
			}
		}
	};
	x.openPicker = function(param) {
		var that = this;
		if (that.isApp()) {
			if (that.isJson(param)) {
				param = that.setData({}, [config.openPicker, param], true);
				api.openPicker(param, function(ret, err) {
					if (that.isFunction(param.success)) {
						param.success(ret);
					}
				});
			} else {
				api.openPicker(config.openPicker, function(ret, err) {
					if (that.isFunction(param)) {
						param(ret);
					}
				});
			}
		};
	};
	x.getPicture = function(param) {
		var that = this;
		if (that.isApp()) {
			param = that.setData({}, [config.getPicture, param], true);
			api.getPicture(param, function(ret, err) {
				if (that.isFunction(param.success)) {
					param.success(ret.data);
				}
			});
		};
	};
	x.addEvent = function(name, callback) {
		var that = this;
		if (that.isApp()) {
			if (x.isJson(name)) {
				api.addEventListener(name, function(ret, err) {
					if (that.isFunction(callback)) {
						callback(ret);
					}
				});
			} else {
				api.addEventListener({
					name : name
				}, function(ret, err) {
					if (that.isFunction(callback)) {
						callback(ret);
					}
				});
			}
		};
	};
	x.removeEvent = function(name) {
		if (this.isApp()) {
			api.removeEventListener({
				name : name
			});
		};
	};
	x.sendEvent = function(name, param) {
		if (this.isApp()) {
			api.sendEvent({
				name : name,
				extra : param
			});
		}
	};
	x.fixStatusBar = function() {
		var ver = this.systemVersion;
		if (this.systemType == 'ios') {
			ver = parseInt(ver, 10);
			if (ver < 7 && !this.fullScreen) {
				return 0;
			} else {
				return 20;
			}
		} else {
			ver = parseFloat(ver);
			if (ver < 4.4) {
				return 0;
			} else {
				return 25;
			}
		}
	};
	// APICloud属性
	var apiProps = ["appId", "appName", "appVersion", "systemType", "systemVersion", "version", "deviceId", "deviceToken", "deviceModel", "deviceName", "operator", "connectionType", "fullScreen", "screenWidth", "screenHeight", "winName", "winWidth", "winHeight", "frameName", "frameWidth", "frameHeight", "pageParam", "wgtParam", "appParam", "statusBarAppearance", "wgtRootDir", "fsDir", "cacheDir"];
	apiProps.forEach(function(prop) {
		Object.defineProperty(x, prop, {
			get : function() {
				var that = this;
				if (!that.isApp()) {
					if (prop == 'winWidth') {
						return document.body.offsetWidth;
					} else {
						return;
					}
				}
				return api[prop];
			}
		});
	});
	// APICloud 监听事件
	var apiEvents = ["batterylow", "batterystatus", "keyback", "keymenu", "volumeup", "volumedown", "offline", "online", "pause", "resume", "scrolltobottom", "shake", "takescreenshot", "swipedown", "swipeleft", "swiperight", "swipeup", "tap", "longpress", "viewappear", "viewdisappear", "noticeclicked", "appintent", "smartupdatefinish", "launchviewclicked"];
	apiEvents.forEach(function(event) {
		x[event] = function(callback) {
			var param = {};
			param.name = event;
			param = this.setData({}, [config[event], param], true);
			this.addEvent(param, callback);
		};
	});
	x.pageDown = function(fn) {
		if (this.isApp()) {
			api.pageDown(function(ret, err) {
				if (!ret.scrolled) {
					if (x.isFunction(fn)) {
						fn();
					}
				}
			})
		}
	}
})(Xui);

//APICloud方法语法糖
;(function(x) {
	x.openPage = function(param) {
		if (this.isJson(param)) {
			if (!param.win) {
				return;
			}
		} else if (this.isString(param)) {
			var win = param;
			param = {
				win : win
			}
		} else {
			return;
		}
		var pageUrl = param.win.indexOf('user') > -1 ? 'admin' : 'home';
		param.arg = param.arg || {};
		param.arg.toWin = param.win;
		param.arg.sourceWin = x.winName;
		param.arg.sourceFrame = x.frameName;
		if (param.win == 'member') {
			if (param.arg.userid == x.getUser('userid')) {
				param.win = 'my';
			}
		}
		//admin路径下的页面 需要登录
		if (pageUrl == 'admin') {
			if (!x.getUser('userid')) {
				param.win = 'login';
				pageUrl = 'home';
			} else {
				if (param.win == 'userSafe' || param.win == 'userAddCer') {
					if (x.getUser('username').length != 11) {
						param.win = 'userbindPhone';
					}
				};
				if (param.win == 'userAdd') {
					if (param.arg.classid == 8) {
						var user = x.getUser(['sex', 'cityId', 'helpProject']);
						if (!user.sex || !user.cityId || !user.helpProject) {
							param.win = 'userMemberEdit';
						}
					}else if(param.arg.classid==2){
						if(x.getUser('groupid')!=2){
							param.win='userAddCer'
							x.toast({
								msg : '发布活动需要认证爱心大使',
								global : true
							})
						}
					}
				}
			}
		}
		param.pageParam = {};
		param.url = this.wgtRootDir + '/html/header.html';
		param.name = param.win;
		param.pageParam.name = param.win;
		param.pageParam.url = pageUrl + "/" + param.win + ".html";
		if (x.isJson(param.arg)) {
			param.pageParam.pageParam = param.arg;
		}
		x.openWin(param)
	};
	x.post = function(param) {
		param.method = 'post';
		param.url = param.url || '/e/extend/app/admin.php';
		param.url = this.url + param.url;
		param.data.source = 'app';
		//输入会员数据
		if (!(param.data.enews == 'register' || param.data.enews == 'login' || param.data.enews == 'reset' || param.data.enews == 'authLogin')) {
			var userInfo = x.getUser(['userid', 'username', 'groupid', 'rnd', 'checked']);
			if (param.data.enews != 'EditInfo') {
				userInfo.nickname = x.getUser('nickname');
			}
			param.data = this.setData({}, [param.data, userInfo], true);
		}
		if (this.isApp()) {
			param.data = {
				values : param.data,
				files : param.files
			};
		}
		if (x.isFunction(param.init)) {
			param.init();
		}
		this.ajax(param);
	};
	x.get = function(param) {
		var that = this;
		if (x.isFunction(param.init)) {
			param.init();
		}
		if (that.isArray(param.data)) {
			param.enews = param.enews || 'queryInfo';
			var data = [], success = [], error = [];
			param.data.forEach(function(v) {
				data.push(v.data);
				success.push(v.success);
				error.push(v.error);
			})
			that.ajax({
				url : that.url + '/e/extend/app/home.php?enews=' + param.enews + '&json=' + JSON.stringify(data),
				success : function(ret) {
					ret.list.forEach(function(v, k) {
						if (v.state == 'yes') {
							if (that.isFunction(success[k])) {
								success[k](v.list || v);
							}
						} else {
							if (that.isFunction(error[k])) {
								error[k](v);
							}
						}
					})
					if (ret.state == 'yes') {
						if (x.isFunction(param.success)) {
							param.success();
						}
					} else {
						if (x.isFunction(param.error)) {
							param.error();
						}
					}
				},
				error : function(ret) {
					that.toast(ret.msg);
				}
			});
		} else {
			param.enews = param.enews || 'queryInfoOne';
			param.data = "&" + x.jsonToGet(param.data);
			param.url = that.url + '/e/extend/app/home.php?enews=' + param.enews + param.data;
			that.ajax(param);
		}
	};
	x.getPictureWithCamera = function(callback) {
		var that = this;
		this.actionSheet({
			buttons : ["相册选取", "相机拍摄"],
			success : function(index) {
				switch (index) {
					case 0:
						that.getPicture({
							allowEdit : true,
							success : function(data) {
								callback(data)
							}
						});
						break;
					case 1:
						that.getPicture({
							sourceType : 'camera',
							allowEdit : true,
							success : function(data) {
								callback(data);
							}
						});
						break;
				}
			}
		})
	}
})(Xui);

//APICloud第三方模块
;(function(x) {
	//APICloud第三方模块属性
	var config = {
		UIMediaScanner : {
			type : 'picture',
			classify : true,
			max : 9,
			exchange : true,
			styles : {
				bg : '#FFF',
				mark : {
					position : 'bottom_right'
				},
				nav : {
					bg : '#e67015',
					stateColor : '#FFF',
					cancelColor : '#FFF',
					finishColor : '#FFF',
				}
			}
		}
	};
	var fsObj, //文件处理模块
	FNImageClipObj, //图片裁剪模块
	imageFilterObj, //图片处理模块
	UICityListObj, //城市选择模块
	UIMediaScannerObj, //多图选择模块
	UIChatBoxObj, //聊天输入框模块
	clipBoardObj, //复制粘贴模块
	bMapObj;
	//百度地图模块
	//文件处理模块
	x.fs = {
		exist : function(param) {
			fsObj = fsObj || api.require('fs');
			fsObj.exist(param, function(ret, err) {
				if (ret.exist) {
					if (ret.directory) {
						if (x.isFunction(param.folder)) {
							param.folder();
						}
					} else {
						if (x.isFunction(param.file)) {
							param.file();
						}
					}
				} else {
					if (x.isFunction(param.none)) {
						param.none();
					}
				}
			});
		},
		move : function(param) {
			fsObj = fsObj || api.require('fs');
			fsObj.moveTo(param, function(ret, err) {
				if (ret.status) {
					if (x.isFunction(param.success)) {
						param.success();
					}
				} else {
					if (x.isFunction(param.error)) {
						param.error();
					}
				}
			});
		},
		copy : function(param) {
			fsObj = fsObj || api.require('fs');
			fsObj.copyTo(param, function(ret, err) {
				if (ret.status) {
					if (x.isFunction(param.success)) {
						param.success();
					}
				} else {
					x.alert(err.msg + ' 复制错误:' + err.code);
				}
			})
		},
		rename : function(param) {
			fsObj = fsObj || api.require('fs');
			fsObj.rename(param, function(ret, err) {
				var status = ret.status;
				if (status) {
					if (x.isFunction(param.success)) {
						param.success();
					}
				} else {
					x.alert(err.msg + ' 重命名错误:' + err.code);
				}
			});
		},
		remove : function(param) {
			fsObj = fsObj || api.require('fs');
			fsObj.remove(param, function(ret, err) {
				var status = ret.status;
				if (status) {
					if (x.isFunction(param.success)) {
						param.success();
					}
				} else {
					x.alert(err.msg + ' 删除错误:' + err.code);
				}
			});
		}
	};

	x.FNImageClip = {
		open : function(param) {
			FNImageClipObj = FNImageClipObj || api.require('FNImageClip');
			FNImageClipObj.open({
				rect : {
					x : 0,
					y : 0,
					h : x.frameHeight - 50,
					w : x.winWidth,
				},
				srcPath : param.path,
				style : {
					mask : 'rgba(255,255,255,0.4)',
					clip : {
						w : x.winWidth - 120,
						h : x.winWidth - 120,
						x : 60,
						y : (x.winHeight / 2) - (x.winWidth / 2 - 60),
						borderWidth : 1
					}
				},
				mode : 'image',
				fixedOn : x.frameName
			}, function(ret, err) {
				if (ret.status) {
					if (x.isFunction(param.success)) {
						param.success();
					}
				}
			});
		},
		save : function(param) {
			FNImageClipObj.save(param, function(ret, err) {
				if (ret) {
					if (x.isFunction(param.success)) {
						param.success(ret.destPath);
					}
				} else {
					x.alert(err.msg);
				}
				x.FNImageClip.close();
			});
		},
		close : function() {
			FNImageClipObj.close();
			FNImageClipObj = null;
		},
		reset : function() {
			FNImageClipObj.reset();
		}
	};

	x.imageFilter = {
		compress : function(param) {
			param.w = param.w || 720;
			param.h = param.h || param.w;
			param.quality = param.quality || 1;
			param.savePath = param.savePath || 'userpic';
			param.saveName = param.saveName || 'user' + x.getUser('userid');
			imageFilterObj = imageFilterObj || api.require('imageFilter');
			imageFilterObj.compress({
				img : param.path,
				quality : param.quality,
				save : {
					imgPath : x.fsDir + '/' + param.savePath + '/',
					imgName : param.saveName + '.jpg'
				},
				size : {
					w : param.w,
					h : param.h
				}
			}, function(ret, err) {
				if (ret.status) {
					if (x.isFunction(param.success)) {
						param.success(x.fsDir + '/' + param.savePath + '/' + param.saveName + '.jpg');
					}
				} else {
					if (x.isFunction(param.error)) {
						param.error(err);
					}
				}
			});
		},
		getAttr : function(param) {
			imageFilterObj = imageFilterObj || api.require('imageFilter');
			imageFilterObj.getAttr(param, function(ret, err) {
				if (ret.status) {
					if (x.isFunction(param.success)) {
						param.success(ret);
					}
				}
			});
		}
	}

	x.UICityList = {
		open : function(callback) {
			UICityListObj = api.require('UICityList');
			UICityListObj.open({
				rect : {
					x : 0,
					y : 45 + x.getConfig('fixStatusBar'),
					w : api.winWidth,
					h : api.winHeight - (45 + x.getConfig('fixStatusBar'))
				},
				styles : {
					searchBar : {
						bgColor : '#696969',
						cancelColor : '#E3E3E3'
					},
					location : {
						color : '#696969',
						size : 12
					},
					sectionTitle : {
						bgColor : '#eee',
						color : '#000',
						size : 12
					},
					item : {
						bgColor : '#fff',
						activeBgColor : '#696969',
						color : '#000',
						size : 14,
						height : 40
					},
					indicator : {
						bgColor : '#fff',
						color : '#696969'
					}
				},
				currentCity:x.getConfig('cityName'),
				resource : 'widget://res/UICityList.json'
			}, function(ret, err) {
				if (ret.eventType == 'show') {
					x.keybackCloseModule('x.UICityList.close()');
				}
				if (ret.eventType == 'selected') {
					if (x.isFunction(callback)) {
						callback(ret.cityInfo);
					}
					x.UICityList.close();
				}
			});
		},
		close : function() {
			UICityListObj.close();
			UICityListObj = null;
			x.execScript(x.winName, '', 'x.removeEvent("keyback")');
		}
	};

	x.UIMediaScanner = {
		open : function(param) {
			UIMediaScannerObj = UIMediaScannerObj || api.require('UIMediaScanner');
			param = x.setData({}, [config.UIMediaScanner, param], true);
			UIMediaScannerObj.open(param, function(ret) {
				if (ret) {
					if (x.isFunction(param.success)) {
						param.success(ret.list);
					}
				}
			});
		},
		transPath : function(param) {
			UIMediaScannerObj = UIMediaScannerObj || api.require('UIMediaScanner');
			UIMediaScannerObj.transPath(param, function(ret) {
				if (x.isFunction(param.success)) {
					param.success(ret.path);
				}
			});
		}
	};

	x.imageBrowser = function(param) {
		var obj = api.require('imageBrowser');
		obj.openImages({
			imageUrls : param.imageUrls || [],
			showList : param.showList || false,
			activeIndex : param.index || 0
		});
	}
	//百度地图API
	x.bMap = {
		getLocation : function(param) {
			bMapObj = bMapObj || api.require('bMap');
			bMapObj.getLocation({
				accuracy : '100m'
			}, function(ret, err) {
				if (ret.status) {
					if (x.isFunction(param.success)) {
						param.success(ret);
					}
				} else {
					if (x.isFunction(param.error)) {
						param.error(err);
					}
				}
			});
		},
		getNameFromCoords : function(param) {
			bMapObj.getNameFromCoords({
				lon : param.lon,
				lat : param.lat
			}, function(ret, err) {
				if (ret.status) {
					if (x.isFunction(param.success)) {
						param.success(ret);
					}
				} else {
					if (x.isFunction(param.error)) {
						param.error(err);
					}
				}
			});
		}
	};
	x.clipBoard = {
		set : function(text,callback) {
			if(!text){
				x.toast('请选择内容');
				return false;
			}
			clipBoardObj = clipBoardObj || api.require('clipBoard');
			clipBoardObj.set({
				value : text
			}, function(ret, err) {
				if (ret) {
					if(x.isFunction(callback)){
						callback();
					}
				}
			});
		}
	}
	//聊天模块
	x.UIChatBox = {
		open : function(param) {
			UIChatBoxObj = UIChatBoxObj || api.require('UIChatBox');
			param = param || {};
			param.placeholder = param.placeholder || '';
			UIChatBoxObj.open({
				placeholder : param.placeholder,
				emotionPath : 'widget://res/emotion',
				styles : {
					emotionBtn : {
						normalImg : 'widget://res/chatBox_face1.png'
					},
					keyboardBtn : {
						normalImg : 'widget://res/chatBox_key1.png'
					},
					indicator : {
						target : 'both'
					},
					sendBtn : {
						titleColor : '#FFF',
						bg : '#e67015',
						activeBg : '#d67015',
						titleSize : 14
					}
				}
			}, function(ret) {
				//点击发送按钮
				if (ret.eventType == 'send') {
					if (!ret.msg) {
						return false;
					}

					if (x.isFunction(param.success)) {
						param.success(ret.msg);
					};

				};
				if (ret.eventType == 'show') {
					//UIChatBoxObj.popupKeyboard();
					if (param.tapClose) {
						x.addEvent('tap', function() {
							x.UIChatBox.close(true);
						})
					}
				}
			});
		},
		close : function(tap) {
			UIChatBoxObj.close();
			if (tap) {
				x.removeEvent('tap');
			}
		}
	};

	//微信
	x.wx = {
		installed : function(callback) {
			var obj = api.require('wx');
			obj.isInstalled(function(ret, err) {
				if (ret.installed) {
					if (x.isFunction(callback)) {
						callback();
					};
				}
				obj = null;
			});
		},
		login : function(callback) {
			var obj = api.require('wx');
			obj.auth({}, function(ret, err) {
				if (ret.status) {
					obj.getToken({
						code : ret.code
					}, function(ret, err) {
						if (ret.status) {
							obj.getUserInfo({
								accessToken : ret.accessToken,
								openId : ret.openId
							}, function(ret, err) {
								if (ret.status) {
									if (x.isFunction(callback)) {
										callback(ret);
									};
								} else {
									x.hideProgress();
									x.toast('微信登陆错误：' + err.code);
								}
								obj = null;
							});
						} else {
							x.hideProgress();
							x.toast('微信accessToken授权错误：' + err.code);
							obj = null;
						}
					});
				} else {
					x.hideProgress();
					if (err.code == 1) {
						x.toast('用户取消');
					} else if (err.code == 2) {
						x.toast('用户拒绝授权');
					} else {
						x.toast('微信授权错误：' + err.code);
					}
					obj = null;
				};
			});
		},
		shareWebpage : function(param) {
			if (param.img) {
				var savePath = api.fsDir + '/cache/' + param.classid + param.id + '.jpg';
				x.fs.exist({
					path : savePath,
					file : function() {
						param.img = savePath;
						wxShare()
					},
					none : function() {
						//压缩图片
						param.img = x.timthumb({
							w : 150,
							h : 150,
							url : param.img
						})
						x.showProgress({
							title : '图片下载中...'
						});
						//下载图片
						x.download({
							url : param.img,
							savePath : savePath,
							success : function(ret) {
								x.hideProgress();
								param.img = savePath;
								wxShare();
							},
							error : function(ret) {
								x.hideProgress();
								param.img = x.wgtRootDir + '/image/logo150.png';
								wxShare();
							}
						})
					}
				})
			} else {
				param.img = x.wgtRootDir + '/image/logo150.png';
				wxShare();
			}
			function wxShare() {
				var obj = api.require('wx');
				obj.shareWebpage({
					scene : param.scene,
					title : param.title,
					description : param.des,
					thumb : param.img,
					contentUrl : param.url
				}, function(ret, err) {
					if (ret.status) {
						if (x.isFunction(param.success)) {
							param.success();
						};
					} else {
						if (err.code == 2) {
							x.toast('已取消分享');
						} else if (err.code == 3) {
							x.toast('发送失败');
						} else if (err.code == 4) {
							x.toast('授权拒绝');
						} else {
							x.toast('未知错误');
						}
					}
					obj = null;
				});
			}

		},
		pay : function(param) {
			x.wxPay = x.wxPay || api.require('wxPay');
			param.money = param.money * 100;
			x.wxPay.config(function(ret, err) {
				if (ret.status) {
					x.wxPay.pay({
						description : param.des,
						totalFee : param.money,
						tradeNo : param.orderNo,
						detail : param.title
					}, function(ret, err) {
						if (ret.status) {
							if (x.isFunction(param.success)) {
								param.success();
							};
						} else {
							if (err.code == -2) {
								x.toast('用户取消');
							} else {
								x.toast(err.msg);
							}
							if (x.isFunction(param.error)) {
								param.error();
							};
						}
					});
				} else {
					x.alert(err.code);
				}
			});
		}
	};
	//qq
	x.qq = {
		installed : function(callback) {
			var obj = api.require('qq');
			obj.installed(function(ret, err) {
				if (ret.status) {
					if (x.isFunction(callback)) {
						callback();
					};
				};
				obj = null;
			});
		},
		login : function(callback) {
			var obj = api.require('qq');
			obj.login(function(ret, err) {
				if (ret.status) {
					var openId = ret.openId;
					//获取信息
					obj.getUserInfo(function(ret, err) {
						if (ret.status) {
							ret.info['openid'] = openId;
							if (x.isFunction(callback)) {
								callback(ret.info);
							};
						} else {
							x.hideProgress();
							x.toast('QQ用户信息获取错误：' + err.code);
						}
						obj = null;
					});
				} else {
					x.hideProgress();
					x.toast('QQ登陆错误：' + err.msg);
					obj = null;
				};
			})
		},
		shareNews : function(param) {
			if (!param.img) {
				param.img = x.url + '/skin/default/images/logo150.png';
			}
			var obj = api.require('qq');
			obj.shareNews({
				url : param.url,
				title : param.title,
				description : param.des,
				imgUrl : param.img,
				type : param.type
			}, function(ret, err) {
				if (ret.status) {
					if (x.isFunction(param.success)) {
						param.success();
					};
				} else {
					x.toast(err.msg);
				}
				obj = null;
			});
		}
	};
	x.wb = {
		isInstalled : function(callback) {
			var weibo = api.require('weibo');
			weibo.isInstalled(function(ret) {
				if (ret.status) {
					if (x.isFunction(callback)) {
						callback();
					};
				}
			});
		},
		login : function(callback) {
			var weibo = api.require('weibo');
			weibo.auth(function(ret, err) {
				if (ret.status) {
					weibo.getUserInfo({
						token : ret.token,
						userId : ret.userId
					}, function(ret, err) {
						if (ret.status) {
							x.hideProgress();
							if (x.isFunction(callback)) {
								callback(ret.userInfo);
							};
						} else {
							x.hideProgress();
							x.toast('微博登陆错误：' + err.code);
						}
					});
				} else {
					x.hideProgress();
					x.toast('微博授权错误：' + err.code);
				}
			});
		},
		shareWebPage : function(param) {
			if (param.img) {
				var savePath = api.fsDir + '/cache/' + param.classid + param.id + '.jpg';
				x.fs.exist({
					path : savePath,
					file : function() {
						param.img = savePath;
						wbShare()
					},
					none : function() {
						//压缩图片
						param.img = x.timthumb({
							w : 150,
							h : 150,
							url : param.img
						})
						x.showProgress({
							title : '图片下载中...'
						});
						//下载图片
						x.download({
							url : param.img,
							savePath : savePath,
							success : function(ret) {
								x.hideProgress();
								param.img = savePath;
								wbShare();
							},
							error : function() {
								x.hideProgress();
								param.img = x.wgtRootDir + '/image/logo150.png';
								wbShare();
							}
						})
					}
				})
			} else {
				param.img = x.wgtRootDir + '/image/logo150.png';
				wbShare();
			}
			function wbShare() {
				var weibo = api.require('weibo');
				weibo.shareWebPage({
					text : param.title,
					title : param.title,
					description : param.des,
					thumb : param.img,
					contentUrl : param.url
				}, function(ret, err) {
					if (ret.status) {
						x.toast('分享成功');
					} else {
						if (err.code == 1) {
							x.toast('取消分享');
						} else {
							x.toast('分享失败');
						}
					}
				});
			}

		}
	};
	//支付宝
	x.aliPay = function(param) {
		var aliPay = api.require('aliPay');
		aliPay.pay({
			subject : param.title,
			body : param.des,
			amount : param.money,
			tradeNO : param.orderNo
		}, function(ret, err) {
			if (ret.code == 9000) {
				if (x.isFunction(param.success)) {
					param.success();
				};
			} else {
				if (ret.code == 6001) {
					x.toast('取消交易');
				} else {
					x.toast('错误码：' + ret.code);
				}
				if (x.isFunction(param.error)) {
					param.error();
				};
			}
		});
	}
	//侦听keyback模块关闭事件
	x.keybackCloseModule = function(script) {
		if (x.frameName) {//子页面
			x.execScript(api.winName, '', 'x.keybackCloseModule("' + script + '")');
		} else {//主页面
			x.addEvent('keyback', function() {
				//执行窗口
				x.execScript(x.winName, script);
				x.removeEvent('keyback');
			})
		}

	};
	x.backCloseWin = function() {
		if (UICityListObj) {
			x.UICityList.close();
		} else if (FNImageClipObj) {
			x.FNImageClip.close();
		} else {
			x.closeWin();
		}
	}
})(Xui);

//业务设置
;(function(x) {
	x.menu = [{
		fid : 1,
		fname : '爱心帮扶'
	}, {
		fid : 29,
		fname : '志愿辅导'
	}, {
		fid : 30,
		fname : '志愿导游'
	}, {
		fid : 31,
		fname : '校园公益'
	}, {
		fid : 32,
		fname : '上门医疗'
	}, {
		fid : 2,
		fname : '人权帮扶'
	}, {
		fid : 3,
		fname : '看病挂号'
	}, {
		fid : 4,
		fname : '退伍军转'
	}, {
		fid : 5,
		fname : '支教助学'
	}, {
		fid : 6,
		fname : '毕业分配'
	}, {
		fid : 7,
		fname : '上学择校'
	}, {
		fid : 8,
		fname : '影艺安排'
	}, {
		fid : 9,
		fname : '上层人脉'
	}, {
		fid : 10,
		fname : '人事安排'
	}, {
		fid : 11,
		fname : '程序办理'
	}, {
		fid : 12,
		fname : '资源合作'
	}, {
		fid : 13,
		fname : '公司注销'
	}, {
		fid : 14,
		fname : '工商注册'
	}, {
		fid : 15,
		fname : '招商引资'
	}, {
		fid : 16,
		fname : '移民求学'
	}, {
		fid : 17,
		fname : '汽车服务'
	}, {
		fid : 18,
		fname : '购物打折'
	}, {
		fid : 19,
		fname : '二手设备'
	}, {
		fid : 20,
		fname : '农品分销'
	}, {
		fid : 21,
		fname : '房产关系'
	}, {
		fid : 22,
		fname : '就业兼职'
	}, {
		fid : 23,
		fname : '教育培训'
	}, {
		fid : 24,
		fname : '家政服务'
	}, {
		fid : 25,
		fname : '结伴旅行'
	}, {
		fid : 26,
		fname : '情感生活'
	}, {
		fid : 27,
		fname : '动漫游戏'
	}, {
		fid : 28,
		fname : '其它类别'
	}];
	x.gift = ['nut', 'flower', 'apple', 'chocolate', 'bear', 'star'];
	x.giftName = ['坚果', '玫瑰花', '红苹果', '巧克力', '泰迪熊', '幸运星'];
	x.giftMoney = [5, 10, 50, 100, 500, 1000];
})(Xui);

//业务方法
;(function(x) {
	//缩略图
	x.timthumb = function(param) {
		if (!param.url)
			return '';
		return x.url + '/timthumb/timthumb.php?src=' + param.url + '&w=' + param.w + (param.h ? '&h=' + param.h : '') + '&q=90&zc=1&ct=1';
	};
	//获取验证码
	x.getVerify = function() {
		if (vm.isSend)
			return;
		//验证手机号
		var reg = /^13[0-9]{9}$|14[0-9]{9}|15[0-9]{9}$|18[0-9]{9}$|17[0-9]{9}$/;
		if (!reg.test(vm.data.username || vm.data.phone)) {
			x.toast('手机号格式不正确');
			vm.isSend = false;
			return false;
		}
		//获取验证码
		vm.isSend = true;
		vm.codeText = vm.authCode + 'S';
		var isinerval = setInterval(function() {
			if (vm.authCode < 1) {
				vm.codeText = '重新获取';
				vm.isSend = false;
				vm.authCode = 60;
				clearInterval(isinerval);
				return;
			}
			vm.codeText = vm.authCode + 'S';
			vm.authCode--;
		}, 1000);
		x.get({
			enews : 'sendAuth',
			data : {
				phone : vm.data.username || vm.data.phone
			},
			success : function(ret) {
				x.toast(ret.msg);
			}
		})
	};
	//上传头像
	x.uploadUserPic = function() {
		x.post({
			data : {
				enews : 'uploadUserPic'
			},
			files : {
				file : x.getUser('localUserPic')
			},
			success : function(ret) {
				if (ret.state == 'yes') {
				} else {
					x.alert(ret.msg);
				}
			}
		})
	};
	//下载头像
	x.downloadUserPic = function() {
		var userid = x.getUser('userid');
		var localUserPic = x.getUser('localUserPic');
		if (userid > 0) {
			x.download({
				url : x.url + '/userpic/user' + userid + '.jpg',
				savePath : localUserPic
			})
		}
	}
	//下载第三方登录头像
	x.downloadAuthPic = function(param) {
		x.download({
			url : param.headimgurl,
			savePath : api.fsDir + '/userpic/user' + param.userid + '.jpg'
		})
	}
	//删除信息
	x.delInfo = function(param) {
		param = param || {};
		if (param.data.classid > 0 && param.data.id > 0) {
			param.data.enews = 'MDelInfo';
			x.post({
				url : '/e/DoInfo/ecms.php',
				data : param.data,
				success : function(ret) {
					if (x.isFunction(param.success)) {
						param.success(ret);
					}
				},
				error : function(ret) {
					x.toast(ret.msg);
				}
			})
		} else {
			x.toast('信息不存在');
		}
	};
	x.delInfoIndex = function(param) {
		var list = [];
		if (param.sourceWin == 'root' && param.sourceFrame == 'index') {
			if (param.classid == 7) {
				list = vm.list2;
			} else if (param.classid == 8) {
				list = vm.list3;
			} else if (param.classid == 2) {
				list = vm.list1;
			}
		} else {
			list = vm.list;
		}
		list.some(function(v, index) {
			if (v.id == param.id && v.classid == param.classid) {
				list.splice(index, 1);
				if (param.classid == 2) {
					setTimeout(function() {
						indexSlide.update();
					}, 300)
				}
				return true;
			}
		})
	};
	//上传信息
	x.postInfo = function(filepass) {
		var info = x.getInfo(filepass);
		x.zipPic(info.files, function(zipFiles) {
			x.post({
				data : info.data,
				files : zipFiles,
				report : false,
				success : function(ret) {
					setTimeout(function() {
						x.removeInfo(filepass);
					}, 1000)
					if (ret.state == 'yes') {
						x.toast({
							msg : ret.msg,
							global : true
						});
					}
				},
				error : function(ret) {
					console.log(JSON.stringify(ret));
				}
			})
		})
	};
	//压缩图片
	x.zipPic = function(files, callback) {
		var index = 0, w = 960, h = 0, zipFiles = {};
		if (files.length > 0) {
			whileZip();
		} else {
			if (x.isFunction(callback)) {
				callback();
			}
		}
		//var v = {};
		function whileZip() {
			var v = files[index];
			if (x.systemType == 'ios') {
				//相册
				if (v.path.indexOf('asset') > -1) {
					x.UIMediaScanner.transPath({
						path : v.path,
						success : function(path) {
							v.path = path;
							getAttr(v);
						}
					})
				} else {
					getAttr(v);
				}
			} else {
				getAttr(v);
			}
			function getAttr(v) {
				x.imageFilter.getAttr({
					path : v.path,
					success : function(ret) {
						if (ret.width > 0) {
							if (ret.width > w) {
								h = (w / ret.width).toFixed(3);
								h = parseInt(h * ret.height);
							} else {
								w = ret.width;
								h = ret.height;
							}
							x.imageFilter.compress({
								path : v.path,
								w : w,
								h : h,
								savePath : 'cache',
								saveName : v.name,
								success : function(zipPath) {
									index++;
									zipFiles[index] = zipPath;
									if (index == files.length) {
										if (x.isFunction(callback)) {
											callback(zipFiles);
										}
									} else {
										//console.log(zipPath);
										whileZip();
									}
								},
								error : function(msg) {
									x.alert('compress:' + JSON.stringify(msg));
								}
							})
						} else {
							index++;
							if (index == files.length) {
								if (x.isFunction(callback)) {
									callback(zipFiles);
								}
							} else {
								//console.log(zipPath);
								whileZip();
							}
						}
					}
				})
			}

		}

	};
	//点赞
	x.addPraise = function(param) {
		param.data.enews = 'praise';
		x.post({
			data : param.data,
			success : function(ret) {
				if (x.isFunction(param.success)) {
					param.success(ret);
				}
			},
			error : function(ret) {
				x.toast(ret.msg);
			}
		});
	};
	//评论
	x.addComment = function(param) {
		var user = x.getUser(['userid', 'nickname']);
		var placeholder = param.data.isRep > 0 ? "回复" + param.data.info_nickname : '自古评论出人才...';
		x.UIChatBox.open({
			placeholder : placeholder,
			tapClose : true,
			success : function(msg) {
				if (msg) {
					param.data.msgText = msg;
					param.data.enews = 'addPl';
					x.post({
						data : param.data,
						success : function(ret) {
							param.data.id = ret.id;
							param.data.userid = user.userid;
							param.data.nickname = user.nickname;
							param.data.sendTime = ret.sendTime;
							if (x.isFunction(param.success)) {
								x.UIChatBox.close(true);
								if (param.data.msgText) {
									param.data.msgText = x.replaceFace(param.data.msgText);
								}
								param.success(param.data);
							}
						},
						error : function(ret) {
							x.toast(ret.msg);
						}
					})
				} else {
					x.toast('请输入内容');
					return false;
				}
			}
		})
	};
	//删除评论
	x.delPl=function(param){
		param.data.enews='delPl';
		x.post({
			data:param.data,
			init:function(){
				x.showProgress();
			},
			success:function(ret){
				x.hideProgress();
				x.toast(ret.msg);
				if(x.isFunction(param.success)){
					param.success();
				}
			},
			error:function(ret){
				x.hideProgress();
				x.toast(ret.msg);
				if(x.isFunction(param.error)){
					param.error();
				}
			}
		})
	}
	//表情替换
	x.replaceFace = function(msg) {
		var reg = null;
		for (var i = 0, max = emotion.length; i < max; i++) {
			reg = new RegExp('\\' + emotion[i].text, "g");
			msg = msg.replace(reg, '<img src="../../res/emotion/' + emotion[i].name + '.png">');
		}
		return msg;
	}
	//字段替换
	x.replaceField = function(list, rep) {
		if (x.isArray(list)) {
			list.forEach(function(v) {
				v = replaceFun(v);
			})
		} else if (x.isJson(list)) {
			list = replaceFun(list);
		}
		function replaceFun(v) {
			rep.forEach(function(arg) {
				if (x.isString(arg)) {
					if (arg == 'showtime') {
						v.showtime = x.dateDiff(v.truetime || v.sendTime);
					} else if (arg == 'newstext') {
						if (!v.newstext)
							return v.newstext;
						v.content = [];
						v.images = [];
						if (v.newstext.indexOf("|||") < 0) {
							return v.newstext
						}
						var index = 0;
						v.newstext.split(":::").forEach(function(arr) {
							arr.split("|||").forEach(function(e, i) {
								if (i == 0) {
									if (e) {
										v.content.push({
											index : -1,
											text : e.replace(/\n/g, "<br/>")
										});
									}
								} else {
									if (e) {
										e.split(",").forEach(function(img) {
											v.content.push({
												index : index,
												text : x.timthumb({
													url : x.fileUrl + v.classpath + '/' + img + '.jpg',
													w : x.winWidth * 1.5
												})
											});
											v.images.push(x.fileUrl + v.classpath + '/' + img + '.jpg')
											index++;
										})
									}
								}
							})
						})
					} else if (arg == 'chargeText') {
						if (v.classid == 8) {
							if (v.isCharge > 1) {
								v.chargeText = '收费帮助';
							} else {
								v.chargeText = '爱心帮扶';
							}
						} else if (v.classid == 7) {
							if (v.isCharge > 1) {
								v.chargeText = '出资求助';
							} else {
								v.chargeText = '爱心帮扶';
							}
						} else if (v.classid == 2) {
							if (v.isCharge > 1) {
								v.chargeText = '出资活动';
							} else {
								v.chargeText = '爱心活动';
							}
						} else {
							v.chargeText = '';
						}
					} else if (arg == 'fname') {
						if (!v.fid) {
							v.fname = '';
						} else {
							x.menu.some(function(e) {
								if (e.fid == v.fid) {
									v.fname = e.fname;
									return true;
								}
							})
						}
					} else if (arg == 'helpProjectText') {
						v.helpProjectText = '';
						if (v.helpProject) {
							var helpProjectText = [];
							v.helpProject.split(',').forEach(function(v) {
								x.menu.some(function(e) {
									if (e.fid == v) {
										helpProjectText.push(e.fname);
										return true;
									}
								})
							})
							v.helpProjectText = helpProjectText.join();
						};
					} else if (arg == 'needText') {
						v.needText = '';
						if (v.need) {
							var needText = [];
							v.need.split(',').forEach(function(v) {
								x.menu.some(function(e) {
									if (e.fid == v) {
										needText.push(e.fname);
										return true;
									}
								})
							})
							v.needText = needText.join();
						}
					} else if (arg == 'msgText') {
						v.msgText = x.replaceFace(v.msgText);
					} else if (arg == 'abilityList') {
						if (v.ability) {
							v.abilityList = v.ability.split(',');
						}
					} else if (arg == 'needList') {
						if (v.need) {
							v.needList = v.need.split(',');
						}
					} else if (arg == 'myStateList') {
						if (v.myState) {
							v.myStateList = v.myState.split(',');
						}
					} else if (arg == 'activeState') {
						var todayTime = x.initTime();
						var applyEndTime = Date.parse(v.applyEndTime.replace(/-/gi, "/")) / 1000;
						var startTime = Date.parse(v.startTime.replace(/-/gi, "/")) / 1000;
						var endTime = Date.parse(v.endTime.replace(/-/gi, "/")) / 1000;
						if (applyEndTime > todayTime) {
							v.activeState = '报名中';
							v.activeStateColor = 'x-label-main';
						} else if (todayTime > applyEndTime && todayTime < startTime) {
							v.activeState = '报名结束';
							v.activeStateColor = 'x-label-main';
						} else if (endTime > todayTime && todayTime > startTime) {
							v.activeState = '进行中';
							v.activeStateColor = 'aui-label-danger';
						} else {
							v.activeState = '已结束';
							v.activeStateColor = '';
						}
					} else if (arg == 'isFocus') {
						v.isFocus = x.isFocus(v.userid);
					}
				} else {
					if (arg.name == 'userpic') {
						if (x.isApp()) {
							if (v.userid == x.getUser('userid')) {
								v.userpic = x.getUser('localUserPic');
							} else {
								v.userpic = x.timthumb({
									url : x.url + '/userpic/user' + v.userid + '.jpg',
									w : arg.w,
									h : arg.h
								});
							}
						} else {
							v.userpic = x.timthumb({
								url : x.url + '/userpic/user' + v.userid + '.jpg',
								w : arg.w,
								h : arg.h
							});
						}
					} else if (arg.name == 'msgUserPic') {
						var userid = v.userid;
						if (v.userid == x.getUser('userid')) {
							userid = v.info_userid;
						}
						v.userpic = x.timthumb({
							url : x.url + '/userpic/user' + userid + '.jpg',
							w : arg.w,
							h : arg.h
						});
					} else if (arg.name == 'info_userpic') {
						v.info_userpic = x.timthumb({
							url : x.url + '/userpic/user' + v.info_userid + '.jpg',
							w : arg.w,
							h : arg.h
						});
					} else if (arg.name == 'titlepic') {
						if (!v.titlepic)
							return v.titlepic;
						v.titlepic = x.timthumb({
							url : v.titlepic,
							w : arg.w,
							h : arg.h
						});
					} else if (arg.name == 'info_titlepic') {
						if (!v.info_titlepic)
							return v.info_titlepic;
						v.info_titlepic = x.timthumb({
							url : v.info_titlepic,
							w : arg.w,
							h : arg.h
						});
					} else if (arg.name == 'listPicArr') {
						var length = v.listPic.split("|||").length
						if (length > 2) {
							v.listPicArr = [];
							v.listPic.split("|||").forEach(function(img) {
								if (img.indexOf('://') == -1) {
									img = x.fileUrl + v.classpath + '/' + img + '.jpg';
								}
								v.listPicArr.push(x.timthumb({
									url : img,
									w : arg.w,
									h : arg.h
								}));
							})
						} else {
							v.listPicArr = undefined;
						}
					}
				}
			})
			return v;
		}

		return list;
	};
	//分享
	x.openShare = function(param) {
		var shareButtons = [];
		if (x.getConfig('wxClient')) {
			shareButtons.push('微信朋友圈', '微信好友');
		}
		if (x.getConfig('qqClient')) {
			shareButtons.push('QQ空间', 'QQ好友');
		}
		if (x.getConfig('wbClient')) {
			shareButtons.push('新浪微博');
		}
		x.actionSheet({
			buttons : shareButtons,
			success : function(index, value) {
				if (value == '微信朋友圈') {
					param.scene = 'timeline';
					x.wx.shareWebpage(param);
				} else if (value == '微信好友') {
					param.scene = 'session';
					x.wx.shareWebpage(param);
				} else if (value == 'QQ空间') {
					param.type = 'QZone';
					x.qq.shareNews(param);
				} else if (value == 'QQ好友') {
					param.type = 'QFriend';
					x.qq.shareNews(param);
				} else if (value == '新浪微博') {
					x.wb.shareWebPage(param);
				}
			}
		})
	};
	//在线支付
	x.payment = function(param) {
		if (!x.getUser('userid')) {
			x.toast('请先登录会员');
			x.showProgress();
			setTimeout(function() {
				x.openPage('login');
			}, 500)
			return false;
		}
		x.confirm({
			msg : '您真的要支付吗?',
			success : function() {
				x.loveBeansPay(param);
			}
		})
	};
	x.loveBeansPay = function(param) {
		if (Number(param.money) > x.getUser('money')) {
			x.toast('您的爱心豆不足,请充值');
			setTimeout(function() {
				x.openPage('userTopup');
			}, 500)
			return false;
		}
		x.post({
			data : {
				enews : 'payment',
				info_classid : param.classid,
				info_id : param.id,
				info_userid : param.info_userid
			},
			init : function() {
				x.showProgress();
			},
			success : function(ret) {
				x.toast(ret.msg);
				x.setUser(ret);
				x.hideProgress();
			},
			error : function(ret) {
				x.toast(ret.msg);
				x.setUser(ret);
				x.hideProgress();
				if (ret.state == 'noMoney') {
					setTimeout(function() {
						x.openPage('userTopup');
					}, 500)
				}
			}
		})
	};
	x.onlinePay = function(param) {
		x.actionSheet({
			buttons : ['微信', '支付宝'],
			success : function(index, value) {
				x.confirm({
					msg : '您真的要支付吗?',
					success : function() {
						x.showProgress();
						x.post({
							data : {
								enews : 'topUp',
								money : param.money,
								pay : value,
								orderNo : param.orderNo
							},
							success : function(ret) {
								if (index == 0) {
									x.wx.pay(param);
								} else {
									x.aliPay(param);
								}
							},
							error : function(ret) {
								x.toast(ret.msg);
								x.hideProgress();
							}
						})
					}
				})
			}
		})
	};
	//消息发布
	x.sendMsg = function(data) {
		data.enews = 'sendMsg';
		x.post({
			data : data,
			success : function(ret) {

			},
			error : function(ret) {
				x.toast({
					msg : ret.msg,
					global : true
				});
			}
		})
	}
})(Xui)
document.body.addEventListener('touchstart', function() {
});
